
public class TextUtils {

	public static String fmt( String str, int width )
	{
		char c, c2;
		int count = 0;
		StringBuffer sb = new StringBuffer();
		
		for( int i = 0; i < str.length(); i++ ) {
			c = str.charAt( i );
			
			if( c > 127 ) {
				count += 2;
				sb.append( c );
			} else if( c == 0x09 ) {
				// 遇到 tab 時加四
				// FIXME: magic number
				count += 4;
				sb.append( c );					
			} else if( c == 0x0a || c == 0x0d ) {
				// 遇到換行
				c = 0x0d;
				count = 0;
				sb.append( c );
			} else {
				count++;
				sb.append( c );
			}
			
			if( count > width ) {

				// TODO: 斷行的演算法要再加強
				// FIXME: 用 c > 127 判斷是否為中文
				// 這裡的作法類似於 fmt -width
				// 中文到處皆可換行，英文只在空白處換行
				for( int j = sb.length() - 1; j >= 0; j-- ) {
					c2 = sb.charAt( j );
					if( c2 > 127 ) {
						sb.insert( j, (char)0x0d );
						count = sb.length() - j - 1;
						break;
					} else if( c2 == ' ' ) {
						sb.setCharAt( j, (char)0x0d );
						count = sb.length() - j - 1;
						break;
					} else if( c2 == (char)0x0d ) {
						// 整行都遇不到中文或空白，沒辦法處理
						break;
					}
				}
			}
		}
		
		return new String( sb );
	}
}
